{
  "openapi": "3.1.0",
  "info": {
    "title": "CargoSoft API",
    "description": "# About the CargoSoft API\n\n## General\n\n> Attention: Since our API is still under development, endpoints may well change, or object structures may change. Of course, we try to avoid this as much as possible, but we cannot guarantee it. So that you have the possibility to react in time, we will soon offer you a possibility to subscribe to a newsletter. We would then inform all subscribers when something will change in the API. We are currently still looking for an integrable solution for newsletters, which can be used to subscribe and unsubscribe at this place. Until then, we would like to ask you to send us an email to support@cargosoft.de with the request that we inform you when there are planned changes to the API.\n\n## Authorization\n\n<p id='CHAPTER_AUTHORIZATION'></p>\nThe following chapter will explain the authorization prozess to access the CargoSoft API endpoints. The use case figure below shows a common example how to retrieve the JWT and how to use it.\n\n![Authorization][SeqAuthorization]\n\n[SeqAuthorization]: https://raw.githubusercontent.com/cargosoft-gmbh/cargosoft-api-docs/2026.1/resources/Seq_authentifizierung.svg \"Use case Authorization\"\n\n### Retrieve a token\n\nFirst of all each client has to request a bearer Java Web Toke (JWT) from the CargoSoft API. To receive a JWT, username\nand password are required. Username and password can only be created by CargoSoft.\nFor more details [see](#operation/retrieveAuthToken).\n\n> Please note: The JWT is valid for 24 hours. After that you have to request a new one.\n\n### Access API endpoints\n\nTo access the CargoSoft API endpoint, a JWT is required. The JWT has to be sent in the HTTP authorization header.\n\n**Example**: This example shows a minimal curl with a bearer authorization header. The token is not valid because we\nonly want to illustrate the structure.\n\n```\ncurl --location --request POST 'https://api-demo.cargosoft.de/cargosoft/shipment/lookup' \\\n--header 'Authorization: Bearer eyJ0eXAiOiJqd3QiLCJhbGciOiJSUzI1NiJ9.eyJzdWIiOiJ1cGRhdGUiLCJjYXJnb3NvZnQtand0LNjc2NDQ1NTAzfQ.mK82rjSu0ltd0bf3mvXUqwpME05ck5OEuqnzsAQ8WPFPo' \\\n--data-raw '[]'\"\n```\n\n> Attention: Your user may be restricted. The CargoSoft API uses a permission system to grant access to the\n> CargoSoft API endpoint. If your user is restricted or it's not allowed to use an endpoint you need please contact our\n> support.\n\n### Access webhook\n\nThe webhook uses basic auth as its authorization type.\n\n**Example**: This example shows a minimal curl request, to access the webhook. The basic auth is not valid.\n\n```\ncurl --location --request POST 'https://api-demo.cargosoft.de/external/webhook' \\\n--header 'Authorization: Basic cG9ydg53xcvgawawb3J0YmFzZWNj' \\\n--data-raw '{}'\"\n```\n\n> Please note: Your user needs a special role to access the webhook endpoint via basic auth.\n\n## CRUD\n\nThe CargoSoft API uses CRUD operations. We attempt to implement each CRUD operation for each functional\ngroup of endpoints if it makes sense. The delete operation is one of the most sensitive function and will not\navailable to each function group.\n\n### Lookup\n\nThe CargoSoft API extends the CRUD retrieve operations with lookup operations. Each functional group of endpoints should\nhave a lookup method implemented.\nLookups should be used to search functional objects with given criteria named identifiers. The identifiers may be\ndifferent to each functional group. To find out which functional identifier are possible, please take a look at the\ncorresponding functional group.\n\nThe identifier will be sent in the request body to the API lookup endpoint. An identifier contains the following\nthree information:\n\n1. _match_mode_: The match mode can alter the behaviour, how the criteria is compared against the object in the database\n   are **[EQUALS, CONTAINS, IN, OR, GT, LT, GE, LE]**.\n2. _key_: The key of the criteria for the functional object to lookup. To find out which keys are possible, please check\n   the\n   corresponding implementation.\n3. _value_: The value of the criteria.\n\n**Example**: Lookup request body to search a shipment\n\n```json\n[\n  {\n    \"match_mode\": \"EQUALS\",\n    \"key\": \"MBL\",\n    \"value\": \"MASTER_12345\"\n  },\n  {\n    \"match_mode\": \"EQUALS\",\n    \"key\": \"MODE_OF_TRANSPORT\",\n    \"value\": \"SEA\"\n  }\n]\n```\n\n> Please note: When using one of any lookup methods, please define search criteria as precisely as possible to limit the\n> result of objects.\n\nThe lookup may contain ordering by one or more criteria. The ordering will passed as a query parameter.\n\nThe result set of a lookup includes zero up to n functional objects depending on the search criteria.\nEach functional object contains an ID. The ID can be used to retrieve additional information by passing the id as a path\nparameter of the retrieve endpoint.\n\n**Example**: Lookup a shipment and retrieve all shipment events\n\n1. Looking up a shipment with given criteria, for instance with the BL number. For more details\n   please [see](#operation/lookup).\n2. Extract the ID of the shipment result object.\n3. Call the [Events](#operation/{id}/events) endpoint with the shipment ID as path parameter.\n\n### Pagination\n\nMost endpoints of the CargoSoft API use pagination mechanics.\n\nThe pagination information will be sent as a request query parameter to the API endpoint. The pagination contains the\nfollowing two query parameter:\n1. _page_no_: The current number of the page\n2. _page_size_: The size of the page\n\n**Example**: Lookup a shipment with pagination query parameter\n```\ncurl --location --request POST 'https://api-demo.cargosoft.de/cargosoft/shipment/lookup?page_no=1&page_size=5' \\\n--header 'Authorization: Bearer eyJ0eXAiOiJqd3QiLCJhbGciOiJSUzI1NiJ9.eyJzdWIiOiJ1cGRhdGUiLCJjYXJnb3NvZnQtand0LNjc2NDQ1NTAzfQ.mK82rjSu0ltd0bf3mvXUqwpME05ck5OEuqnzsAQ8WPFPo' \\\n--header 'Content-Type: application/json' \\\n--data '[\n    {\n        \"match_mode\": \"EQUALS\",\n        \"key\": \"MBL\",   \n        \"value\": \"MASTER_12345\"\n    },\n   {\n        \"match_mode\": \"EQUALS\",\n        \"key\": \"MODE_OF_TRANSPORT\",\n        \"value\": \"SEA\"\n    }\n]'\n```\n\nThe response contains two additional headers:\n1. _X-Page-Count_: The total number of pages.\n2. _X-Row-Count_: The total number of found objects.\n\nWith these both headers it is possible to scroll through a result set.\n\n## Testing\n\nFor testing purposes CargoSoft hosted a server with the last released CargoSoft API.\n\n**URL**: https://api-demo.cargosoft.de\n\nTo use the test environment, please use the \"Try it\" console in this documentation. Login credentials are needed to use\nthe test API. The credentials have to be requested from the CargoSoft support. The received information grants access to\na\ntest account which should be able to use all endpoints. If any endpoint is restricted, please contact CargoSoft. Please\nhave in mind that the test environment will be reset every night!\n\n# Use cases\n\n## Retrieve a shipment\n\nTo retrieve a shipment, the [lookup](#operation/lookup) endpoint of the shipment functional group is one of\nthe common possibilities that should be used. The following figure shows the use case to look up a shipment. To keep the\nfigure simple, the authorization process is referred.\n\n![RetrieveShipment][SeqRetrieveShipment]\n\n[SeqRetrieveShipment]: https://raw.githubusercontent.com/cargosoft-gmbh/cargosoft-api-docs/2026.1/resources/Seq_retrieve_shipment.svg \"Use case to retrieve a shipment\"\n\n1. To access the lookup endpoint a JWT is needed. For more details how to retrieve a JWT [see](#CHAPTER_AUTHORIZATION).\n2. When a JWT is present, the shipment lookup endpoint can be called. Shipment identifier have to be sent in the request\n   body to reduce the response result. For a complete list of shipment identifier\n   see [here](#operation/lookup).\n\n## Retrieve shipment status\n\nCargoSoft has different pools in which status information are stored. These are described in detail in the next\nsubsections. However, in order to understand the differences\nexactly, the following graphic tries to clarify how the status message flow works.\n\n![ShipmentStatus][useCaseShipmentStatus]\n\n[useCaseShipmentStatus]: https://raw.githubusercontent.com/cargosoft-gmbh/cargosoft-api-docs/2026.1/resources/Use_case_shipment_status.svg \"Use case to retrieve shipment events\"\n\n### Shipment provider status\n\nThese status messages come from external status providers and service providers who supply CargoSoft with status\ninformation.\nThey cannot be entered or changed by CargoSoft employees by hand. A shipment provider status always represents exactly\none state - planned / estimated or the actual date and time (depending on the name of the status). The codes of the\nstatuses are defined by the providers and are variable depending on the provider.\n\n> Please note: There is no endpoint to retrieve provider status from the CargoSoft API yet. This endpoint will be\n> implemented in a later release.\n\n### Shipment status\n\nCargoSoft customers can define this status code themselves. In addition, the shipment provider statuses can be mapped\ninto a shipment status if the CargoSoft customer configured his basic data accordingly. Here, for example, it can be\ndefined that the status\nABC of provider XYZ has to be processed as shipment status ETA. In this case ETA would be a freely defined code for the\nstatus. Therefore, there is no list of valid codes.\n\nWith this status, there are also two forms of date information per data record. Once a planned and an actual one. This\nmeans that a status ETA, although obviously planned, can contain an actual date. However, this is due to the recording\nof the customer's data.\n\nThe CargoSoft customer can add this status information manually, but an existing record can no longer be changed.\n\n> Please note: There is no endpoint to retrieve CargoSoft status from the CargoSoft API yet. This endpoint will be\n> implemented in a later release.\n\n### Shipment events\n\nShipment events are status events that are defined by CargoSoft. These events are fixed and can always be called up -\nunless there is no data available for the shipment. For a complete list of shipment event codes\nsee [here](#operation/retrieveEvents).\nA shipment event can be created automatically from a shipment or provider status if this is set in the CargoSoft master\ndata. A status always represents exactly one instance - planned or actual and the information can be changed at any time\nby hand, but also by background processes.\n\n![RetrieveShipmentEvents][SeqRetrieveShipmentEvents]\n\n[SeqRetrieveShipmentEvents]: https://raw.githubusercontent.com/cargosoft-gmbh/cargosoft-api-docs/2026.1/resources/Seq_retrieve_shipment_event.svg \"Use case to retrieve shipment events\"",
    "contact": {
      "name": "Uwe Droste",
      "url": "https://www.cargosoft.de",
      "email": "support@cargosoft.de"
    },
    "version": "2026.1",
    "x-logo": {
      "backgroundColor": "#FFFFF",
      "altText": "CargoSoft GmbH",
      "url": "https://raw.githubusercontent.com/cargosoft-gmbh/cargosoft-api-docs/2026.1/resources/CargoSoftLogo.jpg"
    }
  },
  "servers": [
    {
      "url": "https://api-demo.cargosoft.de",
      "description": "Test CargoSoft API server."
    }
  ],
  "tags": [
    {
      "name": "Shipment",
      "description": "The following chapter will give you an overview about the shipment endpoints and their function."
    }
  ],
  "paths": {
    "/cargosoft/efile": {
      "post": {
        "tags": [
          "E-File"
        ],
        "summary": "Create an E-File document.",
        "description": "Stores a base64 encoded document in E-File and links it to the supplied references and roles.",
        "operationId": "create",
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EFile"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Record created",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EFile"
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/efile/{id}/reference": {
      "get": {
        "tags": [
          "E-File"
        ],
        "summary": "Retrieve references from an E-File document.",
        "description": "Retrieves all references linked to an E-File document.",
        "operationId": "retrieveReferencesFromDocument",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "E-File document ID.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int64"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "References retrieved.",
            "content": {
              "application/json": {
                "schema": {
                  "items": {
                    "$ref": "#/components/schemas/EFileReference"
                  }
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      },
      "post": {
        "tags": [
          "E-File"
        ],
        "summary": "Add a reference to an E-File document.",
        "description": "Adds a reference, such as a shipment or address reference, to an existing E-File document.",
        "operationId": "createReferenceForDocument",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "E-File document ID.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int64"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EFileReference"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Reference added."
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      },
      "delete": {
        "tags": [
          "E-File"
        ],
        "summary": "Remove a reference from an E-File document.",
        "description": "Removes a reference from an existing E-File document.",
        "operationId": "deleteReferenceFromDocument",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "E-File document ID.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int64"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EFileReference"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Reference removed."
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/efile/{id}/role": {
      "get": {
        "tags": [
          "E-File"
        ],
        "summary": "Retrieve roles from an E-File document.",
        "description": "Retrieves all authorization roles linked to an E-File document.",
        "operationId": "retrieveRolesFromDocument",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "E-File document ID.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int64"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Roles retrieved.",
            "content": {
              "application/json": {
                "schema": {
                  "items": {
                    "$ref": "#/components/schemas/EFileRole"
                  }
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      },
      "post": {
        "tags": [
          "E-File"
        ],
        "summary": "Add a role to an E-File document.",
        "description": "Adds an authorization role to an existing E-File document.",
        "operationId": "createRoleForDocument",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "E-File document ID.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int64"
            }
          }
        ],
        "requestBody": {
          "content": {
            "text/plain": {
              "schema": {
                "type": "string"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Role added."
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      },
      "delete": {
        "tags": [
          "E-File"
        ],
        "summary": "Remove a role from an E-File document.",
        "description": "Removes an authorization role from an existing E-File document.",
        "operationId": "deleteRoleFromDocument",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "E-File document ID.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int64"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EFileRole"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Role removed."
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/efile/{id}": {
      "get": {
        "tags": [
          "E-File"
        ],
        "summary": "Retrieve an E-File document.",
        "description": "Retrieves a single E-File document by its document ID.",
        "operationId": "retrieveById",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "E-File document ID.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "cascade",
            "in": "query",
            "schema": {
              "type": "boolean",
              "default": false
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Record retrieved",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EFile"
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      },
      "delete": {
        "tags": [
          "E-File"
        ],
        "summary": "Delete an E-File document.",
        "description": "Deletes an E-File document by its document ID.",
        "operationId": "delete",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "E-File document ID.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Record deleted",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EFile"
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/efile/lookup": {
      "post": {
        "tags": [
          "E-File"
        ],
        "summary": "Lookup E-File documents.",
        "description": "Looks up electronic documents such as PDF files by the supplied lookup identifiers.",
        "operationId": "lookup",
        "parameters": [
          {
            "name": "page_no",
            "in": "query",
            "description": "The page number for pagination.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 0
            }
          },
          {
            "name": "page_size",
            "in": "query",
            "description": "The page size for pagination.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 50
            }
          },
          {
            "name": "order_by",
            "in": "query",
            "description": "The order by for ordering API results sending back as response.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string",
                "description": "The following list will give an overview about the implemented efile identifier and a short description.",
                "enum": [
                  "REFERENCE",
                  "SHIPMENT_ID"
                ],
                "title": "EFileIdentifier",
                "x-enumDescriptions": {
                  "SHIPMENT_ID": "Unique database ID of the Shipment.",
                  "REFERENCE": "Reference of the efile. In most cases, this reference is not known by third party applications. For instance, use the SHIPMENT_ID identifier to search efile documents."
                }
              }
            }
          },
          {
            "name": "order_mode",
            "in": "query",
            "description": "The order mode for ordering API results sending back as response.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string",
                "description": "Description of the order mode for ordering API results sending back as response",
                "enum": [
                  "ASC",
                  "DESC"
                ],
                "x-enumDescriptions": {
                  "ASC": "ascending",
                  "DESC": "descending"
                }
              }
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "items": {
                  "$ref": "#/components/schemas/EFileLookupGenericClass"
                }
              },
              "examples": {
                "LookupEFileIdentifierExample": {
                  "summary": "Example of looking up electronic documents for a shipment.",
                  "description": "LookupEFileIdentifierExample",
                  "$ref": "#/components/examples/Lookup_efile_example"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Records found",
            "headers": {
              "X-Page-Count": {
                "description": "The total number of pages for pagination.",
                "required": true,
                "style": "simple",
                "schema": {}
              },
              "X-Row-Count": {
                "description": "The total number of found objects for pagination.",
                "required": true,
                "style": "simple",
                "schema": {}
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "items": {
                    "$ref": "#/components/schemas/EFile"
                  }
                },
                "examples": {
                  "ShipmentEFileExample": {
                    "summary": "Example to retrieve shipment documents.",
                    "description": "Example response for shipment documents.",
                    "$ref": "#/components/examples/Efile_example_object"
                  }
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/shipment/lookup": {
      "post": {
        "tags": [
          "Shipment"
        ],
        "summary": "Lookup for shipments",
        "description": "This endpoint looks up shipments. The result should be limit by using search criterias in the request body. For a complete list of search criteria see the ShipmentIdentifier enumeration below. Depending on the search criteria you will receive zero up to n shipments. This endpoint only returns the base shipment. If you need the full shipment details, use the shipment id to retrieve them separately.",
        "operationId": "lookup_1",
        "parameters": [
          {
            "name": "page_no",
            "in": "query",
            "description": "The page number for pagination.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 0
            }
          },
          {
            "name": "page_size",
            "in": "query",
            "description": "The page size for pagination.",
            "schema": {
              "type": "integer",
              "format": "int32",
              "default": 50
            }
          },
          {
            "name": "order_by",
            "in": "query",
            "description": "The order by for ordering API results sending back as response.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string",
                "description": "The following list will give an overview about the implemented shipment identifier and a short description.",
                "enum": [
                  "ID",
                  "HBL",
                  "MBL",
                  "FILENUMBER",
                  "SHIPMENT_ID",
                  "ADDRESS_REFERENCE",
                  "DIRECTION",
                  "MODE_OF_TRANSPORT",
                  "MONTH_OF_SERVICE",
                  "CLIENT",
                  "CREATION_DATE",
                  "RUNNING_SEQUENCE_NUMBER",
                  "SHIPMENT_NUMBER",
                  "CUSTOMER_ADDRESS_TYPE",
                  "CUSTOMER_ADDRESS_NUMBER",
                  "SHIPMENT_CLOSED",
                  "LAST_MODIFIED_DATE",
                  "LAST_MODIFIED_TIME"
                ],
                "title": "ShipmentIdentifier",
                "x-enumDescriptions": {
                  "SHIPMENT_ID": "A foreign shipment ID of a third party system. This ID should be unique.",
                  "LAST_MODIFIED_TIME": "The time, when the shipment was last modified.",
                  "DIRECTION": "Direction of the shipment. Possible values are [I, E]. I = import shipments, E = export shipments.",
                  "CREATION_DATE": "System date when the shipment was created.",
                  "LAST_MODIFIED_DATE": "The date, when the shipment was last modified.",
                  "CUSTOMER_ADDRESS_NUMBER": "CargoSoft address number of the customer address.",
                  "FILENUMBER": "CargoSoft shipment number. The shipment number is unique in combination with the client.",
                  "CLIENT": "The CargoSoft client.",
                  "HBL": "House bl number of the Shipment.",
                  "MBL": "Master bL number of the Shipment.",
                  "ADDRESS_REFERENCE": "A address reference at any CargoSoft address of the shipment.",
                  "RUNNING_SEQUENCE_NUMBER": "TBD",
                  "MONTH_OF_SERVICE": "TBD",
                  "CUSTOMER_ADDRESS_TYPE": "CargoSoft address type of the customer address. Possible values are [D, K, G, P, A]",
                  "ID": "Unique database ID of the Shipment.",
                  "MODE_OF_TRANSPORT": "The mode of the shipment. Possible values are [SEA, AIR, RD, RL].",
                  "SHIPMENT_NUMBER": "CargoSoft shipment number. The shipment number is unique in combination with the client.",
                  "SHIPMENT_CLOSED": "Flag if the shipment is done. Possible values are [J, N]."
                }
              }
            }
          },
          {
            "name": "order_mode",
            "in": "query",
            "description": "The order mode for ordering API results sending back as response.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string",
                "description": "Description of the order mode for ordering API results sending back as response",
                "enum": [
                  "ASC",
                  "DESC"
                ],
                "x-enumDescriptions": {
                  "ASC": "ascending",
                  "DESC": "descending"
                }
              }
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "items": {
                  "$ref": "#/components/schemas/ShipmenLookupGenericClass"
                }
              },
              "examples": {
                "LookupShipmentIdentifierExample": {
                  "summary": "Example of looking up shipment",
                  "description": "TBD",
                  "$ref": "#/components/examples/Lookup_shipment_example"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Records found",
            "headers": {
              "X-Page-Count": {
                "description": "The total number of pages for pagination.",
                "required": true,
                "style": "simple",
                "schema": {}
              },
              "X-Row-Count": {
                "description": "The total number of found objects for pagination.",
                "required": true,
                "style": "simple",
                "schema": {}
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "items": {
                    "$ref": "#/components/schemas/Shipment"
                  }
                },
                "examples": {
                  "ShipmentExample": {
                    "summary": "Example of a shipment",
                    "description": "TBD",
                    "$ref": "#/components/examples/Shipment_lookup_example_object"
                  }
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/shipment/{id}/airmaincarriage": {
      "get": {
        "tags": [
          "Shipment"
        ],
        "summary": "Retrieve airfreight shipment main carriage",
        "description": "Retrieve the airfreight main carriage of the shipment with additional details. The CargoSoft Shipment ID is needed to retrieve the main carriage. ",
        "operationId": "retrieveAirMainCarriage",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Record retrieved",
            "content": {
              "application/json": {
                "schema": {
                  "items": {
                    "$ref": "#/components/schemas/AirfreightCarriageLeg"
                  }
                },
                "examples": {
                  "ShipmentAirfreightCarriageExportExample": {
                    "summary": "Airfreight export carriage example",
                    "description": "This example contains 2 legs for an export airfright shipment.",
                    "$ref": "#/components/examples/Retrieve_shipment_airfright_carriage_export_example"
                  },
                  "ShipmentAirfreightCarriageImportExample": {
                    "summary": "Airfreight import carriage example",
                    "description": "This example contains only one leg for a import airfright shipment.",
                    "$ref": "#/components/examples/Retrieve_shipment_airfright_carriage_import_example"
                  }
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIErrorResponse"
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/shipment/{id}": {
      "get": {
        "tags": [
          "Shipment"
        ],
        "summary": "Retrieve shipment",
        "description": "Retrieve a specific shipment with the CargoSoft database id.",
        "operationId": "retrieveById_1",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "Database id of the record you want to retrieve",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "cascade",
            "in": "query",
            "schema": {
              "type": "boolean",
              "default": false
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Record retrieved",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Shipment"
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/shipment/{id}/events": {
      "get": {
        "tags": [
          "Shipment"
        ],
        "summary": "Retrieve shipment events",
        "description": "This endpoint retrieves all events of the shipment. To retrieve the events, the shipment id is needed. It is possible that not all events are included in the response because they are not entered or know in the shipment unitil now. To retrive the shipment id, use the lookup endpoint of this chapter.",
        "operationId": "retrieveEvents",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "The shipment id.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Records found",
            "content": {
              "application/json": {
                "schema": {
                  "items": {
                    "$ref": "#/components/schemas/ShipmentEvent"
                  }
                },
                "examples": {
                  "ShipmentEventExample": {
                    "summary": "Example of shipment events",
                    "description": "TBD",
                    "$ref": "#/components/examples/Retrieve_shipment_events_example"
                  }
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/shipment/{id}/seamaincarriage": {
      "get": {
        "tags": [
          "Shipment"
        ],
        "summary": "Retrieve seafreight shipment main carriage",
        "description": "Retrieve the main carriage of the shipment with additional details.",
        "operationId": "retrieveSeaMainCarriage",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Record retrieved",
            "content": {
              "application/json": {
                "schema": {
                  "items": {
                    "$ref": "#/components/schemas/SeafreightCarriageLeg"
                  }
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIErrorResponse"
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/shipment/{shipmentId}/event": {
      "post": {
        "tags": [
          "Shipment"
        ],
        "summary": "Create a shipment event",
        "description": "Create a shipment event of the given event type. ",
        "operationId": "create_1",
        "parameters": [
          {
            "name": "shipmentId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "type",
            "in": "query",
            "schema": {
              "$ref": "#/components/schemas/EventType"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ShipmentEvent"
              },
              "examples": {
                "ShipmentEventExample": {
                  "summary": "Example of a shipment event",
                  "description": "Create event",
                  "$ref": "#/components/examples/Shipment_event_example_object"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "The event has been created successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ShipmentEvent"
                },
                "examples": {
                  "ShipmentEventExample": {
                    "summary": "Example of a shipment event",
                    "description": "TBD",
                    "$ref": "#/components/examples/Shipment_event_example_object"
                  }
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/cargosoft/shipment/{shipmentId}/event/{id}": {
      "put": {
        "tags": [
          "Shipment"
        ],
        "summary": "Update a shipment event",
        "description": "Update the event of the given event type. ",
        "operationId": "update",
        "parameters": [
          {
            "name": "shipmentId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "type",
            "in": "query",
            "schema": {
              "$ref": "#/components/schemas/EventType"
            }
          },
          {
            "name": "id",
            "in": "path",
            "description": "Database id of the record you want to update.",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/ShipmentEventQualifier"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ShipmentEvent"
              },
              "examples": {
                "ShipmentEventUpdateExample": {
                  "summary": "Full update",
                  "description": "Update DTO",
                  "$ref": "#/components/examples/Shipment_event_example_object"
                },
                "ShipmentEventMinimalUpdateExample": {
                  "summary": "Minimal update",
                  "description": "Minimal update DTO example",
                  "$ref": "#/components/examples/Shipment_event_update_example"
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "The event has been updated successfully.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ShipmentEvent"
                },
                "examples": {
                  "ShipmentEventExample": {
                    "summary": "Example of a shipment event",
                    "description": "TBD",
                    "$ref": "#/components/examples/Shipment_event_example_object"
                  }
                }
              }
            }
          }
        },
        "security": [
          {
            "JavaWebToken": []
          }
        ]
      }
    },
    "/auth/token": {
      "post": {
        "tags": [
          "Authorization"
        ],
        "summary": "Retrieve JWT",
        "description": "Retrieve a Java Web Token to authenticate against the API",
        "operationId": "retrieveAuthToken",
        "requestBody": {
          "content": {
            "application/x-www-form-urlencoded": {
              "schema": {
                "type": "object",
                "properties": {
                  "username": {
                    "type": "string",
                    "description": "Your username"
                  },
                  "password": {
                    "type": "string",
                    "description": "Your password"
                  }
                },
                "required": [
                  "password",
                  "username"
                ]
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Java Web Token",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Jwt"
                }
              }
            }
          },
          "401": {
            "description": "Wrong username and/or password"
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "EFile": {
        "description": "Description of the EFile DTO schema for electronic data like PDF's.",
        "properties": {
          "id": {
            "type": "integer",
            "format": "int64",
            "description": "The unique ID of this document."
          },
          "client": {
            "type": "string",
            "description": "The CargoSoft client."
          },
          "description": {
            "type": "string",
            "description": "Description of this document."
          },
          "bytes": {
            "type": "string",
            "format": "Base64 encoded String",
            "description": "Base64 encoded content of this document."
          },
          "roles": {
            "type": "array",
            "description": "The list of roles. The roles are a kind of authorization as to who may view the documents.",
            "items": {
              "type": "string"
            }
          },
          "references": {
            "type": "array",
            "description": "A list of references.",
            "items": {
              "$ref": "#/components/schemas/EFileReference"
            }
          },
          "document_category": {
            "type": "integer",
            "format": "int32",
            "description": "The category of this document. The category is defined in the CargoSoft basic data and is individual for each customer."
          },
          "document_name": {
            "type": "string",
            "description": "The file name of this document."
          },
          "document_date": {
            "type": "string",
            "format": "date-time",
            "description": "Date of creation of this document."
          }
        }
      },
      "EFileReference": {
        "description": "Description of the EFileReference DTO schema for efile references.",
        "properties": {
          "reference_type": {
            "type": "string",
            "description": "Each reference is typified. The type describes the reference value. For example [CSFILE, ADRFILE]. CSFILE = The document is attached to a shipment, ADRFILE = The document is attached to an address.",
            "examples": [
              "CSFILE",
              "ADRFILE"
            ]
          },
          "reference_value": {
            "type": "string",
            "description": "The reference value."
          }
        }
      },
      "EFileRole": {
        "properties": {
          "role": {
            "type": "string"
          }
        }
      },
      "ContainsIdentifier": {
        "allOf": [
          {
            "$ref": "#/components/schemas/Identifier"
          },
          {
            "type": "object",
            "properties": {
              "value": {
                "type": "string",
                "description": "The value of the identifier."
              }
            }
          },
          {
            "$ref": "#/components/schemas/IdentifierLookupIdentifier"
          },
          {
            "$ref": "#/components/schemas/IdentifierShipmentIdentifier"
          }
        ],
        "description": "This identifier should use when value have to contain.",
        "title": "ContainsIdentifier"
      },
      "EFileLookupGenericClass": {
        "anyOf": [
          {
            "$ref": "#/components/schemas/EqualsIdentifier"
          }
        ],
        "properties": {
          "key": {
            "type": "string",
            "description": "Identifier key. For instance a ShipmentIdentifier",
            "enum": [
              "REFERENCE",
              "SHIPMENT_ID"
            ],
            "title": "EFileIdentifier",
            "x-enumDescriptions": {
              "SHIPMENT_ID": "Unique database ID of the Shipment.",
              "REFERENCE": "Reference of the efile. In most cases, this reference is not known by third party applications. For instance, use the SHIPMENT_ID identifier to search efile documents."
            }
          },
          "match_mode": {
            "type": "string",
            "default": "EQUALS",
            "description": "The match mode.",
            "enum": [
              "EQUALS",
              "CONTAINS",
              "IN",
              "OR",
              "GT",
              "LT",
              "GE",
              "LE"
            ],
            "x-enumDescriptions": {
              "OR": "Or.",
              "EQUALS": "Equals.",
              "IN": "In.",
              "LT": "Lower than.",
              "LE": "Lower equals",
              "CONTAINS": "Contains",
              "GT": "Greater than.",
              "GE": "Greater equals"
            }
          }
        }
      },
      "EqualsIdentifier": {
        "allOf": [
          {
            "$ref": "#/components/schemas/Identifier"
          },
          {
            "type": "object",
            "properties": {
              "value": {
                "type": "string",
                "description": "The value of the identifier."
              }
            }
          },
          {
            "$ref": "#/components/schemas/IdentifierLookupIdentifier"
          },
          {
            "$ref": "#/components/schemas/IdentifierShipmentIdentifier"
          }
        ],
        "description": "The equals identifier should use to match the value exactly.",
        "title": "EqualsIdentifier"
      },
      "GreaterEqualIdentifier": {
        "allOf": [
          {
            "$ref": "#/components/schemas/Identifier"
          },
          {
            "type": "object",
            "properties": {
              "value": {
                "type": "string",
                "description": "The value of the identifier."
              }
            }
          },
          {
            "$ref": "#/components/schemas/IdentifierLookupIdentifier"
          },
          {
            "$ref": "#/components/schemas/IdentifierShipmentIdentifier"
          }
        ],
        "description": "This identifier should use when the value is greater or equals.",
        "title": "GreaterEqualIdentifier"
      },
      "GreaterThanIdentifier": {
        "allOf": [
          {
            "$ref": "#/components/schemas/Identifier"
          },
          {
            "type": "object",
            "properties": {
              "value": {
                "type": "string",
                "description": "The value of the identifier."
              }
            }
          },
          {
            "$ref": "#/components/schemas/IdentifierLookupIdentifier"
          },
          {
            "$ref": "#/components/schemas/IdentifierShipmentIdentifier"
          }
        ],
        "description": "This identifier should use when the value is greater than.",
        "title": "GreaterThanIdentifier"
      },
      "Identifier": {
        "description": "Description of the Identifier DTO schema. This DTO contains the match mode and identifiers of a functional object for instance the shipment identifier.",
        "discriminator": {
          "propertyName": "matchMode",
          "mapping": {
            "EqualsIdentifierMapped": "#/components/schemas/EqualsIdentifier",
            "ContainsIdentifierMapped": "#/components/schemas/ContainsIdentifier",
            "InIdentifierMapped": "#/components/schemas/InIdentifier",
            "OrIdentifierMapped": "#/components/schemas/OrIdentifier",
            "GreaterThanIdentifierMapped": "#/components/schemas/GreaterThanIdentifier",
            "LessThanIdentifierMapped": "#/components/schemas/LessThanIdentifier",
            "GreaterEqualIdentifierMapped": "#/components/schemas/GreaterEqualIdentifier",
            "LessEqualIdentifierMapped": "#/components/schemas/LessEqualIdentifier"
          }
        },
        "properties": {
          "key": {
            "description": "Identifier key. For instance a ShipmentIdentifier"
          },
          "match_mode": {
            "type": "string",
            "default": "EQUALS",
            "description": "The match mode.",
            "enum": [
              "EQUALS",
              "CONTAINS",
              "IN",
              "OR",
              "GT",
              "LT",
              "GE",
              "LE"
            ],
            "x-enumDescriptions": {
              "OR": "Or.",
              "EQUALS": "Equals.",
              "IN": "In.",
              "LT": "Lower than.",
              "LE": "Lower equals",
              "CONTAINS": "Contains",
              "GT": "Greater than.",
              "GE": "Greater equals"
            }
          }
        }
      },
      "IdentifierLookupIdentifier": {
        "description": "Description of the Identifier DTO schema. This DTO contains the match mode and identifiers of a functional object for instance the shipment identifier.",
        "discriminator": {
          "propertyName": "matchMode",
          "mapping": {
            "EqualsIdentifierMapped": "#/components/schemas/EqualsIdentifier",
            "ContainsIdentifierMapped": "#/components/schemas/ContainsIdentifier",
            "InIdentifierMapped": "#/components/schemas/InIdentifier",
            "OrIdentifierMapped": "#/components/schemas/OrIdentifier",
            "GreaterThanIdentifierMapped": "#/components/schemas/GreaterThanIdentifier",
            "LessThanIdentifierMapped": "#/components/schemas/LessThanIdentifier",
            "GreaterEqualIdentifierMapped": "#/components/schemas/GreaterEqualIdentifier",
            "LessEqualIdentifierMapped": "#/components/schemas/LessEqualIdentifier"
          }
        },
        "properties": {
          "key": {
            "description": "Identifier key. For instance a ShipmentIdentifier"
          },
          "match_mode": {
            "type": "string",
            "default": "EQUALS",
            "description": "The match mode.",
            "enum": [
              "EQUALS",
              "CONTAINS",
              "IN",
              "OR",
              "GT",
              "LT",
              "GE",
              "LE"
            ],
            "x-enumDescriptions": {
              "OR": "Or.",
              "EQUALS": "Equals.",
              "IN": "In.",
              "LT": "Lower than.",
              "LE": "Lower equals",
              "CONTAINS": "Contains",
              "GT": "Greater than.",
              "GE": "Greater equals"
            }
          }
        }
      },
      "InIdentifier": {
        "allOf": [
          {
            "$ref": "#/components/schemas/Identifier"
          },
          {
            "type": "object",
            "properties": {
              "values": {
                "type": "array",
                "description": "A list of values of the identifier.",
                "items": {
                  "type": "string"
                }
              }
            }
          },
          {
            "$ref": "#/components/schemas/IdentifierLookupIdentifier"
          },
          {
            "$ref": "#/components/schemas/IdentifierShipmentIdentifier"
          }
        ],
        "description": "This identifier should use when more than one value can be match.",
        "title": "InIdentifier"
      },
      "LessEqualIdentifier": {
        "allOf": [
          {
            "$ref": "#/components/schemas/Identifier"
          },
          {
            "type": "object",
            "properties": {
              "value": {
                "type": "string",
                "description": "The value of the identifier."
              }
            }
          },
          {
            "$ref": "#/components/schemas/IdentifierLookupIdentifier"
          },
          {
            "$ref": "#/components/schemas/IdentifierShipmentIdentifier"
          }
        ],
        "description": "This identifier should use when the value is less or equals.",
        "title": "LessEqualsIdentifier"
      },
      "LessThanIdentifier": {
        "allOf": [
          {
            "$ref": "#/components/schemas/Identifier"
          },
          {
            "type": "object",
            "properties": {
              "value": {
                "type": "string",
                "description": "The value of the identifier."
              }
            }
          },
          {
            "$ref": "#/components/schemas/IdentifierLookupIdentifier"
          },
          {
            "$ref": "#/components/schemas/IdentifierShipmentIdentifier"
          }
        ],
        "description": "This identifier should use when the value is less than.",
        "title": "LessThanIdentifier"
      },
      "LookupIdentifier": {},
      "OrIdentifier": {
        "allOf": [
          {
            "$ref": "#/components/schemas/IdentifierLookupIdentifier"
          },
          {
            "$ref": "#/components/schemas/Identifier"
          },
          {
            "type": "object",
            "properties": {
              "identifiers": {
                "type": "array",
                "description": "A list of identifier",
                "items": {
                  "$ref": "#/components/schemas/IdentifierLookupIdentifier"
                }
              }
            }
          },
          {
            "$ref": "#/components/schemas/IdentifierShipmentIdentifier"
          }
        ],
        "description": "This identifier combines a list of identifier with the logical or.",
        "title": "OrIdentifier"
      },
      "IdentifierEFileIdentifier": {
        "description": "Description of the Identifier DTO schema. This DTO contains the match mode and identifiers of a functional object for instance the shipment identifier.",
        "discriminator": {
          "propertyName": "matchMode",
          "mapping": {
            "EqualsIdentifierMapped": "#/components/schemas/EqualsIdentifier",
            "ContainsIdentifierMapped": "#/components/schemas/ContainsIdentifier",
            "InIdentifierMapped": "#/components/schemas/InIdentifier",
            "OrIdentifierMapped": "#/components/schemas/OrIdentifier",
            "GreaterThanIdentifierMapped": "#/components/schemas/GreaterThanIdentifier",
            "LessThanIdentifierMapped": "#/components/schemas/LessThanIdentifier",
            "GreaterEqualIdentifierMapped": "#/components/schemas/GreaterEqualIdentifier",
            "LessEqualIdentifierMapped": "#/components/schemas/LessEqualIdentifier"
          }
        },
        "properties": {
          "key": {
            "type": "string",
            "description": "Identifier key. For instance a ShipmentIdentifier",
            "enum": [
              "REFERENCE",
              "SHIPMENT_ID"
            ],
            "title": "EFileIdentifier",
            "x-enumDescriptions": {
              "SHIPMENT_ID": "Unique database ID of the Shipment.",
              "REFERENCE": "Reference of the efile. In most cases, this reference is not known by third party applications. For instance, use the SHIPMENT_ID identifier to search efile documents."
            }
          },
          "match_mode": {
            "type": "string",
            "default": "EQUALS",
            "description": "The match mode.",
            "enum": [
              "EQUALS",
              "CONTAINS",
              "IN",
              "OR",
              "GT",
              "LT",
              "GE",
              "LE"
            ],
            "x-enumDescriptions": {
              "OR": "Or.",
              "EQUALS": "Equals.",
              "IN": "In.",
              "LT": "Lower than.",
              "LE": "Lower equals",
              "CONTAINS": "Contains",
              "GT": "Greater than.",
              "GE": "Greater equals"
            }
          }
        }
      },
      "IdentifierListIdentifierEFileIdentifier": {
        "type": "array",
        "items": {
          "$ref": "#/components/schemas/IdentifierEFileIdentifier"
        },
        "properties": {
          "first": {
            "$ref": "#/components/schemas/IdentifierEFileIdentifier"
          },
          "last": {
            "$ref": "#/components/schemas/IdentifierEFileIdentifier"
          }
        }
      },
      "AES": {
        "properties": {
          "id": {
            "type": "integer",
            "format": "int32"
          },
          "client": {
            "type": "string",
            "description": "The CargoSoft client."
          },
          "mrn": {
            "type": "string",
            "description": "The Movement Reference Number assigned to this customs declaration."
          },
          "shipment_number": {
            "type": "string",
            "description": "The CargoSoft shipment number of the shipment."
          },
          "running_number": {
            "type": "integer",
            "format": "int32",
            "description": "Proposal counter"
          }
        }
      },
      "AddressMatchcode": {
        "properties": {
          "address_type": {
            "type": "string",
            "description": "The CargoSoft address type."
          },
          "address_number": {
            "type": "integer",
            "format": "int32",
            "description": "The CargoSoft address number."
          }
        }
      },
      "AirfreightCarriageLeg": {
        "allOf": [
          {
            "$ref": "#/components/schemas/CarriageLeg"
          },
          {
            "type": "object",
            "properties": {
              "flight_no": {
                "type": "string",
                "description": "The flight number of this airfreight carriage."
              },
              "airline_awb_code": {
                "type": "string",
                "description": "The awb number of this airfreight carriage."
              },
              "airline_name": {
                "type": "string",
                "description": "The airline name of this airfreight carriage."
              }
            }
          }
        ],
        "description": "Description of the airfreight carriage DTO schema with several airfreight attributes."
      },
      "CarriageLeg": {
        "description": "Description of the Carriage DTO schema.",
        "discriminator": {
          "propertyName": "mot",
          "mapping": {
            "AirfreightCarriageMapped": "#/components/schemas/AirfreightCarriageLeg",
            "SeafreightCarriageMapped": "#/components/schemas/SeafreightCarriageLeg",
            "RailCarriageMapped": "#/components/schemas/RailCarriageLeg",
            "RoadCarriageMapped": "#/components/schemas/RoadCarriageLeg",
            "GenericCarriageMapped": "#/components/schemas/GenericCarriageLeg"
          }
        },
        "properties": {
          "origin": {
            "$ref": "#/components/schemas/LocationDateTime",
            "description": "The origin of this leg. This object contains several information about the location and its dates and times."
          },
          "destination": {
            "$ref": "#/components/schemas/LocationDateTime",
            "description": "The destination of this leg. This object contains several information about the location and its dates and times."
          },
          "leg_no": {
            "type": "integer",
            "format": "int32",
            "description": "The number for the correct order of the transport legs. Important if more than one leg is entered for the shipment."
          },
          "mot": {
            "type": "string"
          }
        },
        "required": [
          "mot"
        ]
      },
      "Contact": {
        "properties": {
          "name": {
            "type": "string"
          },
          "phone_number": {
            "type": "string"
          },
          "fax_number": {
            "type": "string"
          },
          "email": {
            "type": "string"
          }
        }
      },
      "Container": {
        "description": "Description of the Container DTO. Each container refers to a good element because a container is part of the CargoSoft goods description.",
        "properties": {
          "containerAddresses": {
            "type": "array",
            "description": "List of container addresses. This list contains the three fixed addresses on the container. In addition, further dynamic addresses can be defined and entered on the container.",
            "items": {
              "$ref": "#/components/schemas/ContainerAddress"
            }
          },
          "id": {
            "type": "integer",
            "format": "int32",
            "description": "The unique identifier of this Container."
          },
          "good_id": {
            "type": "integer",
            "format": "int32",
            "description": "The goods id references the associated good element."
          },
          "client": {
            "type": "string",
            "description": "The CargoSoft client"
          },
          "shipment_number": {
            "type": "string",
            "description": "The CargoSoft shipment number, this container belongs to."
          },
          "container_number": {
            "type": "string",
            "description": "The container number"
          },
          "seal_number1": {
            "type": "string",
            "description": "The first seal number."
          },
          "seal_number2": {
            "type": "string",
            "description": "The second seal number"
          },
          "seal_number3": {
            "type": "string",
            "description": "The third seal number"
          },
          "container_iso_code": {
            "type": "string",
            "description": "The ISO code representing the type and size of this container."
          },
          "reefer_temperature": {
            "type": "number",
            "description": "The constant reefer temperature set for this container."
          },
          "reefer_temperature_lower_bound": {
            "type": "number",
            "description": "The lower bound of the reefer temperature range set for this container."
          },
          "reefer_temperature_upper_bound": {
            "type": "number",
            "description": "The upper bound of the reefer temperature range set for this container."
          },
          "reefer_temperature_unit": {
            "type": "string",
            "description": "The physical unit of the reefer temperature."
          },
          "shippers_own": {
            "type": "boolean",
            "description": "Indicates whether the container is owned by the shipper rather than the carrier."
          }
        }
      },
      "ContainerAddress": {
        "description": "Description of the ContainerAddress DTO.",
        "properties": {
          "id": {
            "type": "integer",
            "format": "int32",
            "description": "The id of the dynamic container address. The three fixed container addresses have no id."
          },
          "qualifier": {
            "type": "string",
            "description": "The role of this address. For the three fixed addresses are the following roles dedined [DELIVERER, PICKUP, REDILIVERY]. The roles of the dynamic addresses do not have a fixed qualifier."
          },
          "street": {
            "type": "string",
            "description": "The street of this address."
          },
          "city": {
            "type": "string",
            "description": "The city name of this address."
          },
          "order": {
            "type": "integer",
            "format": "int32",
            "description": "Sequential numbering of the addresses. This is important for the order of the addresses."
          },
          "references": {
            "type": "array",
            "description": "References of this address.",
            "items": {
              "$ref": "#/components/schemas/Reference"
            }
          },
          "address_type": {
            "type": "string",
            "description": "The CargoSoft address type."
          },
          "address_number": {
            "type": "integer",
            "format": "int32",
            "description": "The CargoSoft address number."
          },
          "printed_address": {
            "$ref": "#/components/schemas/PrintedAddress",
            "description": "The address exactly as entered in the shipment record."
          },
          "postal_code": {
            "type": "string",
            "description": "The postal code of this address."
          },
          "country_matchcode": {
            "type": "string",
            "description": "The country code of this address."
          },
          "un_location_code": {
            "type": "string",
            "description": "The city un location code of this address."
          },
          "from_date_and_time": {
            "$ref": "#/components/schemas/DateAndTime",
            "description": "From date and time for an appointment."
          },
          "to_date_and_time": {
            "$ref": "#/components/schemas/DateAndTime",
            "description": "To date and time for an appointment."
          },
          "contact": {
            "$ref": "#/components/schemas/Contact",
            "description": "Additional contact information."
          }
        }
      },
      "CreditData": {
        "properties": {
          "lc_number": {
            "type": "string",
            "description": "The reference number for a Letter of Credit."
          },
          "latest_shipment_date": {
            "type": "string",
            "format": "date"
          },
          "lc_expiry": {
            "type": "string",
            "format": "date",
            "description": "The date when a Letter of Credit becomes invalid."
          }
        }
      },
      "CustomField": {
        "properties": {
          "id": {
            "type": "integer",
            "format": "int32",
            "description": "Unique identifier for this custom field."
          },
          "client": {
            "type": "string",
            "description": "The CargoSoft client"
          },
          "value": {
            "type": "string",
            "description": "The value for this custom field."
          },
          "shipment_number": {
            "type": "string",
            "description": "The CargoSoft shipment number"
          },
          "running_number": {
            "type": "integer",
            "format": "int32",
            "description": "Internal counter."
          }
        }
      },
      "Customs": {
        "properties": {
          "id": {
            "type": "integer",
            "format": "int32"
          },
          "invoice_number": {
            "type": "string"
          },
          "invoice_date_time": {
            "type": "string",
            "format": "date-time"
          },
          "amount": {
            "type": "number"
          },
          "currency_matchcode": {
            "type": "string"
          },
          "delivery_note": {
            "type": "string"
          },
          "delivery_date_time": {
            "type": "string",
            "format": "date-time"
          }
        }
      },
      "CustomsData": {
        "properties": {
          "custom_clearance_date": {
            "type": "string",
            "format": "date",
            "description": "The date when goods are officially cleared by customs"
          },
          "clearance": {
            "type": "string"
          },
          "book": {
            "type": "string",
            "description": "The customs ledger used to record the official clearance of goods"
          }
        }
      },
      "DangerousGood": {
        "description": "Description of the DangerousGood DTO.",
        "properties": {
          "id": {
            "type": "integer",
            "format": "int32",
            "description": "The id of this dangerous goods."
          },
          "dangerous_good_legislation": {
            "type": "string",
            "description": "The dangerous goods legislation. Possible values are IMDG, ADR, or RID."
          },
          "classification_code": {
            "type": "string",
            "description": "Classification code of this dangerous goods. For instance the imdg code."
          },
          "un_number": {
            "type": "string",
            "description": "Dangerous goods UN-Number."
          },
          "release": {
            "type": "string",
            "description": "Dangerous goods release."
          },
          "label_1": {
            "type": "string",
            "description": "Dangerous goods label."
          },
          "label_2": {
            "type": "string",
            "description": "Dangerous goods label."
          },
          "label_3": {
            "type": "string",
            "description": "Dangerous goods label."
          },
          "label_4": {
            "type": "string",
            "description": "Dangerous goods label."
          },
          "site": {
            "type": "string",
            "description": "Dangerous goods site."
          },
          "flashpoint": {
            "type": "string",
            "description": "Flashpoint of this dangerous goods."
          },
          "flashpoint_unit": {
            "type": "string",
            "description": "The unit of the flashpoint. Possible values are C or F."
          },
          "ems_number_1": {
            "type": "string",
            "description": "EMS number."
          },
          "ems_number_2": {
            "type": "string",
            "description": "EMS number."
          },
          "mfag_number_1": {
            "type": "string",
            "description": "MFAG number."
          },
          "mfag_number_2": {
            "type": "string",
            "description": "MFAG number."
          },
          "remarks": {
            "type": "array",
            "description": "Dangerous goods remarks.",
            "items": {
              "type": "string"
            }
          },
          "authorisation_number": {
            "type": "string",
            "description": "Dangerous goods authorisation number."
          },
          "packaging_group": {
            "type": "string",
            "description": "Packaging group of this dangerous goods."
          },
          "technical_name_1": {
            "type": "string",
            "description": "Technical name of this dangerous goods."
          },
          "technical_name_2": {
            "type": "string",
            "description": "Technical name of this dangerous goods."
          },
          "causing_substance_1": {
            "type": "string",
            "description": "Causing substance of this dangerous goods."
          },
          "causing_substance_2": {
            "type": "string",
            "description": "Causing substance of this dangerous goods."
          },
          "issuer": {
            "type": "string",
            "description": "Issuer of this dangerous goods."
          },
          "net_weight": {
            "type": "number",
            "description": "Net weight of this dangerous goods."
          },
          "weight_unit": {
            "type": "string",
            "description": "Weight unit of the net and gross weight."
          },
          "gross_weight": {
            "type": "number",
            "description": "Gross weight of this dangerous goods."
          },
          "contact": {
            "$ref": "#/components/schemas/Contact",
            "description": "Contact information of this dangerous goods."
          }
        }
      },
      "DateAndTime": {
        "properties": {
          "date": {
            "type": "string",
            "format": "ISO-8601",
            "description": "The date."
          },
          "time": {
            "format": "ISO-8601",
            "description": "The time.",
            "properties": {
              "hour": {
                "type": "integer",
                "format": "int32"
              },
              "minute": {
                "type": "integer",
                "format": "int32"
              },
              "second": {
                "type": "integer",
                "format": "int32"
              },
              "nano": {
                "type": "integer",
                "format": "int32"
              }
            }
          },
          "zone_offset": {
            "format": "ISO-8601",
            "description": "The UTC time zone of this date and time.",
            "properties": {
              "totalSeconds": {
                "type": "integer",
                "format": "int32"
              },
              "id": {
                "type": "string"
              },
              "rules": {
                "properties": {
                  "fixedOffset": {
                    "type": "boolean"
                  },
                  "transitions": {
                    "type": "array",
                    "items": {
                      "properties": {
                        "offsetBefore": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "offsetAfter": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "duration": {
                          "properties": {
                            "seconds": {
                              "type": "integer",
                              "format": "int64"
                            },
                            "zero": {
                              "type": "boolean"
                            },
                            "nano": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "negative": {
                              "type": "boolean"
                            },
                            "positive": {
                              "type": "boolean"
                            },
                            "units": {
                              "type": "array",
                              "items": {
                                "properties": {
                                  "durationEstimated": {
                                    "type": "boolean"
                                  },
                                  "timeBased": {
                                    "type": "boolean"
                                  },
                                  "dateBased": {
                                    "type": "boolean"
                                  }
                                }
                              }
                            }
                          }
                        },
                        "gap": {
                          "type": "boolean"
                        },
                        "dateTimeAfter": {
                          "type": "string",
                          "format": "date-time"
                        },
                        "dateTimeBefore": {
                          "type": "string",
                          "format": "date-time"
                        },
                        "instant": {
                          "type": "string",
                          "format": "date-time"
                        },
                        "overlap": {
                          "type": "boolean"
                        }
                      }
                    }
                  },
                  "transitionRules": {
                    "type": "array",
                    "items": {
                      "properties": {
                        "month": {
                          "type": "string",
                          "enum": [
                            "JANUARY",
                            "FEBRUARY",
                            "MARCH",
                            "APRIL",
                            "MAY",
                            "JUNE",
                            "JULY",
                            "AUGUST",
                            "SEPTEMBER",
                            "OCTOBER",
                            "NOVEMBER",
                            "DECEMBER"
                          ]
                        },
                        "timeDefinition": {
                          "type": "string",
                          "enum": [
                            "UTC",
                            "WALL",
                            "STANDARD"
                          ]
                        },
                        "standardOffset": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "offsetBefore": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "offsetAfter": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "dayOfWeek": {
                          "type": "string",
                          "enum": [
                            "MONDAY",
                            "TUESDAY",
                            "WEDNESDAY",
                            "THURSDAY",
                            "FRIDAY",
                            "SATURDAY",
                            "SUNDAY"
                          ]
                        },
                        "dayOfMonthIndicator": {
                          "type": "integer",
                          "format": "int32"
                        },
                        "localTime": {
                          "$ref": "#/components/schemas/LocalTime"
                        },
                        "midnightEndOfDay": {
                          "type": "boolean"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      },
      "EventDateAndTime": {
        "properties": {
          "date": {
            "type": "string",
            "format": "ISO-8601",
            "description": "The date."
          },
          "time": {
            "format": "ISO-8601",
            "description": "The time.",
            "properties": {
              "hour": {
                "type": "integer",
                "format": "int32"
              },
              "minute": {
                "type": "integer",
                "format": "int32"
              },
              "second": {
                "type": "integer",
                "format": "int32"
              },
              "nano": {
                "type": "integer",
                "format": "int32"
              }
            }
          },
          "zone_offset": {
            "format": "ISO-8601",
            "description": "The UTC time zone of this date and time.",
            "properties": {
              "totalSeconds": {
                "type": "integer",
                "format": "int32"
              },
              "id": {
                "type": "string"
              },
              "rules": {
                "properties": {
                  "fixedOffset": {
                    "type": "boolean"
                  },
                  "transitions": {
                    "type": "array",
                    "items": {
                      "properties": {
                        "offsetBefore": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "offsetAfter": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "duration": {
                          "properties": {
                            "seconds": {
                              "type": "integer",
                              "format": "int64"
                            },
                            "zero": {
                              "type": "boolean"
                            },
                            "nano": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "negative": {
                              "type": "boolean"
                            },
                            "positive": {
                              "type": "boolean"
                            },
                            "units": {
                              "type": "array",
                              "items": {
                                "properties": {
                                  "durationEstimated": {
                                    "type": "boolean"
                                  },
                                  "timeBased": {
                                    "type": "boolean"
                                  },
                                  "dateBased": {
                                    "type": "boolean"
                                  }
                                }
                              }
                            }
                          }
                        },
                        "gap": {
                          "type": "boolean"
                        },
                        "dateTimeAfter": {
                          "type": "string",
                          "format": "date-time"
                        },
                        "dateTimeBefore": {
                          "type": "string",
                          "format": "date-time"
                        },
                        "instant": {
                          "type": "string",
                          "format": "date-time"
                        },
                        "overlap": {
                          "type": "boolean"
                        }
                      }
                    }
                  },
                  "transitionRules": {
                    "type": "array",
                    "items": {
                      "properties": {
                        "month": {
                          "type": "string",
                          "enum": [
                            "JANUARY",
                            "FEBRUARY",
                            "MARCH",
                            "APRIL",
                            "MAY",
                            "JUNE",
                            "JULY",
                            "AUGUST",
                            "SEPTEMBER",
                            "OCTOBER",
                            "NOVEMBER",
                            "DECEMBER"
                          ]
                        },
                        "timeDefinition": {
                          "type": "string",
                          "enum": [
                            "UTC",
                            "WALL",
                            "STANDARD"
                          ]
                        },
                        "standardOffset": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "offsetBefore": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "offsetAfter": {
                          "properties": {
                            "totalSeconds": {
                              "type": "integer",
                              "format": "int32"
                            },
                            "id": {
                              "type": "string"
                            }
                          }
                        },
                        "dayOfWeek": {
                          "type": "string",
                          "enum": [
                            "MONDAY",
                            "TUESDAY",
                            "WEDNESDAY",
                            "THURSDAY",
                            "FRIDAY",
                            "SATURDAY",
                            "SUNDAY"
                          ]
                        },
                        "dayOfMonthIndicator": {
                          "type": "integer",
                          "format": "int32"
                        },
                        "localTime": {
                          "$ref": "#/components/schemas/LocalTime"
                        },
                        "midnightEndOfDay": {
                          "type": "boolean"
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          "until": {
            "format": "ISO-8601",
            "description": "Optional time range. Only for Event types: PICKUP and FINAL_DESTINATION",
            "properties": {
              "hour": {
                "type": "integer",
                "format": "int32"
              },
              "minute": {
                "type": "integer",
                "format": "int32"
              },
              "second": {
                "type": "integer",
                "format": "int32"
              },
              "nano": {
                "type": "integer",
                "format": "int32"
              }
            }
          }
        }
      },
      "EventType": {
        "type": "string",
        "description": "The following list will give an overview about the event types and a short description.",
        "enum": [
          "ACTUAL",
          "ESTIMATED"
        ],
        "x-enumDescriptions": {
          "ESTIMATED": "Estimated date and time",
          "ACTUAL": "Actual date and time."
        }
      },
      "GenericCarriageLeg": {
        "allOf": [
          {
            "$ref": "#/components/schemas/CarriageLeg"
          },
          {
            "type": "object",
            "properties": {
              "haulage_type": {
                "type": "string",
                "description": "The method of transporting goods."
              },
              "haulage_reference": {
                "type": "string"
              }
            }
          }
        ]
      },
      "Good": {
        "description": "Description of the Good DTO. Each container refers to a good element because a container is part of the CargoSoft goods description.",
        "properties": {
          "measurements": {
            "type": "array",
            "description": "A list of measurements related to the goods, such as dimensions or additional weights.",
            "items": {
              "$ref": "#/components/schemas/Measurement"
            }
          },
          "customs": {
            "type": "array",
            "description": "Customs-related information for processing the goods.",
            "items": {
              "$ref": "#/components/schemas/Customs"
            }
          },
          "mrns": {
            "type": "array",
            "description": "Movement Reference Numbers (MRNs) associated with customs declarations for the goods.",
            "items": {
              "$ref": "#/components/schemas/MRN"
            }
          },
          "subgoods": {
            "type": "array",
            "description": "Sub-goods or components that form part of the overall goods in the shipment.",
            "items": {
              "$ref": "#/components/schemas/Good"
            }
          },
          "dangerousGoods": {
            "type": "array",
            "description": "Details of dangerous goods information of this good.",
            "items": {
              "$ref": "#/components/schemas/DangerousGood"
            }
          },
          "container": {
            "type": "boolean"
          },
          "id": {
            "type": "integer",
            "format": "int32",
            "description": "Unique identifier for the goods description in the shipment."
          },
          "client": {
            "type": "string",
            "description": "The CargoSoft client."
          },
          "shipment_number": {
            "type": "string",
            "description": "The CargoSoft shipment number of the shipment."
          },
          "identifier": {
            "type": "string"
          },
          "counter": {
            "type": "integer",
            "format": "int32",
            "description": "Counter used to track and number individual goods description lines."
          },
          "level": {
            "type": "integer",
            "format": "int32",
            "description": "The hierarchical level of the goods within the goods description."
          },
          "level_number": {
            "type": "integer",
            "format": "int32",
            "description": "Internal technical number, to order the goods description lines within the CargoSoft TMS."
          },
          "marks": {
            "type": "array",
            "description": "Marks or labels associated with the goods for identification purposes.",
            "items": {
              "type": "string"
            }
          },
          "quantity": {
            "type": "integer",
            "format": "int32",
            "description": "The quantity of goods described in this entry."
          },
          "packaging_matchcode": {
            "type": "string",
            "description": "The matchcode representing the type of packaging used for this good."
          },
          "commodity_matchcode": {
            "type": "string",
            "description": "The matchcode representing the type of commodity being shipped."
          },
          "description": {
            "type": "array",
            "description": "A list providing detailed descriptions of the goods.",
            "items": {
              "type": "string"
            }
          },
          "weight": {
            "type": "number",
            "description": "The total weight of the goods in this shipment."
          },
          "colli": {
            "type": "boolean",
            "description": "Indicates whether this goods description line is a colli line."
          },
          "colli_number": {
            "type": "integer",
            "format": "int32"
          },
          "volume": {
            "type": "number",
            "description": "The total volume."
          },
          "volume_unit": {
            "type": "string",
            "description": "The unit of measurement used for the volume of the goods."
          },
          "additional_mark": {
            "type": "boolean"
          },
          "net_weight": {
            "type": "number",
            "description": "The net weight of the goods, excluding packaging."
          },
          "weight_unit": {
            "type": "string",
            "description": "The unit of measurement for the weight of the goods."
          },
          "chargable_weight": {
            "type": "number",
            "description": "The chargeable weight used for calculating shipping costs, either based on actual or volumetric weight."
          },
          "container_number": {
            "type": "string",
            "description": "The container number in which the goods are stored for shipment."
          },
          "hs_codes": {
            "type": "array",
            "description": "List of Harmonized System (HS) codes for the goods in the shipment.",
            "items": {
              "$ref": "#/components/schemas/HSCode"
            }
          }
        }
      },
      "HSCode": {
        "properties": {
          "id": {
            "type": "integer",
            "format": "int32"
          },
          "goodId": {
            "type": "integer",
            "format": "int32"
          },
          "hsCode": {
            "type": "string"
          }
        }
      },
      "Insurance": {
        "properties": {
          "waiver_customer": {
            "type": "boolean"
          },
          "insurable_value": {
            "type": "number"
          },
          "insurable_value_currency_matchcode": {
            "type": "string"
          },
          "value_of_goods": {
            "type": "number"
          },
          "value_of_goods_currency_matchcode": {
            "type": "string"
          },
          "insurance_text": {
            "type": "string"
          },
          "transport_insurance": {
            "type": "boolean"
          },
          "insurance_type": {
            "type": "string"
          },
          "insurer": {
            "$ref": "#/components/schemas/AddressMatchcode"
          }
        }
      },
      "LocalTime": {
        "properties": {
          "hour": {
            "type": "integer",
            "format": "int32"
          },
          "minute": {
            "type": "integer",
            "format": "int32"
          },
          "second": {
            "type": "integer",
            "format": "int32"
          },
          "nano": {
            "type": "integer",
            "format": "int32"
          }
        }
      },
      "Location": {
        "description": "Description of the Location DTO schema.",
        "properties": {
          "codes": {
            "type": "array",
            "description": "A list of all location codes and their types of this location.",
            "items": {
              "$ref": "#/components/schemas/LocationCode"
            }
          },
          "name": {
[...]
